//
// File: button.cc
// Created by: Joni Valtanen <jvaltane@lpt.fi>
// Created on: Mon Nov  1 23:44:40 2004
//
//
// GNU General Public Licence version 2 - Read COPYING from the package
//

#include "button.h"


button::button()
{
	// TODO: put constructor code here
}

button::button(int x_pos, int y_pos,const char* up_image,const char* down_image)
{
	pressed = false;
	released = false;
	
	x =	x_pos;
	y = y_pos;
	image_d = IMG_Load(down_image);
	image_u = IMG_Load(up_image);
	if(image_d==NULL)
		cout << "Can't load: " << down_image << endl;
	if(image_u==NULL)
		cout << "Can't load: " << up_image << endl;
	w = image_d->w;
	h = image_d->h;	
}

button::~button()
{
	// TODO: put destructor code here
	if(image_d)
		SDL_FreeSurface( image_d );
	if(image_u)
		SDL_FreeSurface( image_u );
}

/*
void button::getPosition()
{
	SDL_Rect rect;
	
	rect.x = x;
	rect.y = y;
	rect.w = image_d->w;
	rect.h = image_d->h;
	
	//return &rect;	
}
*/

bool button::isPressed(int mx, int my, SDL_Surface* screen)
{
	pressed=false;

	#ifdef DEBUG
		cout << mx <<","<< my<<"," << x<<"," << y<<"," << image_d->w<<"," << image_d->h << endl;
	#endif
	
	if( (mx > x) && (mx < (x+image_d->w) ) && 
		(my > y) && (my < (y+image_d->h) ))
	{
		pressed = true;
		released = false;
	}
		
	if(pressed)
		update( screen );

	
	return pressed;
}

bool button::isReleased(int mx, int my, SDL_Surface* screen)
{
	#ifdef DEBUG
		cout << mx <<","<< my<<"," << x<<"," << y<<"," << image_d->w<<"," << image_d->h << endl;
	#endif
	
	if( (mx > x) && (mx < (x+image_d->w) ) && 
		(my > y) && (my < (y+image_d->h) ) && pressed)
	{
		released = true;
		pressed = false;
	}
	else
	{
		released = false;
		pressed = false;
	}
	
//	if(!released && !pressed)
	update( screen );
	
	return released;
}

void button::update(SDL_Surface* destination)
{
	SDL_Rect dstrect;
	
	dstrect.x = x;
	dstrect.y = y;
	dstrect.w = image_u->w;
	dstrect.h = image_u->h;
	
	if( !pressed ) //(!released && !pressed)
		SDL_BlitSurface( image_u, NULL, destination, &dstrect);
	else
		SDL_BlitSurface( image_d, NULL, destination, &dstrect);

	SDL_UpdateRect(destination, dstrect.x,	dstrect.y, dstrect.w, dstrect.h );
}

void button::moveTo(int x_pos, int y_pos)
{
	x = x_pos;
	y = y_pos;	
}
