//
// File: mSDL.h
// SDL class, handles userinterface
//
// Created by: Joni Valtanen <jvaltane@lpt.fi>
// Created on: Sat Oct 30 22:27:40 2004
//
// GNU General Public Licence version 2 - Read COPYING from the package
//

#ifndef _MSDL_H_
#define _MSDL_H_

//#include "defines.h" // allmost all defines

#include <SDL.h>
#include <SDL_image.h>
#include <unistd.h>
#include <cstring>
#include <string>
#include <iostream>
using namespace std;

#include "button.h"
#include "itextbox.h"
#include "statictext.h"
#include "dice.h"

#include "testresult.h"
#include "game.h" // real yatzee engine
#include "file.h"

class mSDL
{
	private:
		Uint32 flags;
		int width, height;
		int bpp;
	
		string pn_quit, pn_winner;
	
		string pn_startDown, pn_startUp;
		string pn_quitUp, pn_quitDown;
		string pn_configUp, pn_configDown;
		string pn_okUp, pn_okDown;
		string pn_cancelUp, pn_cancelDown;
		string pn_backUp, pn_backDown;
		string pn_throwUp, pn_throwDown;
	
		string pn_M[MISSIONS][2];
	
		string pn_OneDown,pn_OneUp;
		string pn_TwoDown,pn_TwoUp;
		string pn_ThreeDown,pn_ThreeUp;
		string pn_FourDown,pn_FourUp;
		string pn_FiveDown,pn_FiveUp;
		string pn_SixDown,pn_SixUp;
	
		string pn_dUp[MAX_DICES], pn_dDown[MAX_DICES];
		string pn_checkUp, pn_checkDown;
	
		string pn_itext1;
		string fn_font1;
	
		SDL_Surface *screen;
		SDL_Surface *tmp;
		SDL_Event event;
		button* bStart;
		button* bQuit;
		button* bConfig;
		button* bOK;
		button* bBack;
		button* bCancel;
		button* bThrow;

		//missions
		button* bM[MISSIONS];
		statictext* mTxt[MAX_PLAYERS][MISSIONS_ALL];


		statictext* sHiText;
		statictext* sPText;
		statictext* sGText;
		statictext* sText[MAX_PLAYERS];
		statictext* fsText;
		statictext* cpnText;
		
//		statictext* hiText0[MAX_HISCORES];
		statictext* hiText[MAX_HISCORES];
		statictext* hiText2[MAX_HISCORES];
		
		statictext* sM[MAX_MTOTAL];
		
		dice* dCheck[MAX_DICES];
	
		game* yGame; //game engine
		hiScore* yHiscore;
		file* yFile;
		
		itextbox* iText[MAX_PLAYERS];
		
		checkbox* check[MAX_PLAYERS];
		checkbox* fsCheck;
		bool isOnGame[MAX_PLAYERS];

	public:
		mSDL();
		mSDL(file *tFile);

		~mSDL();
		int initScreen(game *mGame);
		int closeScreen();
		int drawScreen(const char* pic);
		void drawHiscore( int score, char* name, int i );
	
		int handleMainmenu();
		int handleGameScreen();
		int handleConfigScreen();
		int handleQuit();
		int handleWin();
};


#endif	//_MSDL_H_
