//
// File: statictext.h
// Statictext class for SDL.
//
// Created by: Joni Valtanen <jvaltane@lpt.fi>
// Created on: Tue Nov  2 16:29:22 2004
//
//
// GNU General Public Licence version 2 - Read COPYING from the package
//

#ifndef _STATICTEXT_H_
#define _STATICTEXT_H_

#define MAX_TEXT 255

#include <SDL.h>
#include <SDL_ttf.h>

#include <iostream>
using namespace std;
//#include <cstring>

class statictext
{
	private:
		bool first_time;
		bool active; // is textbox active
		int x, y, w, h, size;
		char value[MAX_TEXT];
	
		SDL_Color fontcolor;
	
		TTF_Font *font;
		SDL_Rect dstrect;
	
		SDL_Surface* textsurface;
		SDL_Surface* dst;
		SDL_Surface* back;

	public:
		statictext();
		statictext( SDL_Surface* destination, int x_pos, int y_pos, int tsize,const char* font_name , char* text);
		 ~statictext();
		void update(SDL_Surface* destination);
		void updateValue(char *cValue);
	
};


#endif	//_STATICTEXT_H_
